#ifndef INC_GTPALETTE_H
#define INC_GTPALETTE_H

#include "gtwidget.h"

/************************************************************************\
*
* GtPalette class header.
*
* $Ident: This file is part of the 'Gt-library' 1.0.0 $
* $Copyright: (C) 1997 by Gran Gustafsson $
*
\************************************************************************/

/* Modes for palette selection */
#define GTPM_SELECT		0
#define GTPM_READ			1

#define GTPM_LAST_NR		1

/* Callback data for palette select */
typedef struct GtPaletteCD
{
	ulong color;
	ulong pixel;
} GtPaletteCD;


class GtPalette : public GtWidget
{
public:
		/* Standard */
	GtPalette(void);
	sbool Init(char *n,GtManager *p,GtTag *tgs);
	sbool Set(GtTag *tgs);
	void Get(GtTag *tgs);
	char *GetClass(void) { return("GtPalette"); }
	sbool IsSubClassOf(char *cn);
		/* Values */
	void SetEMask(ulong em);
		/* Callbacks */
	void AddCB(ulong tag,GtCallB cb,GtUDPtr ud);
	void RemCB(ulong tag,GtCallB cb);
protected:
		/* Internal methods */
	sbool Draw(XEvent *xe);
	sbool Mouse(XEvent *xe);
private:
	void ReDraw(int xp,int yp,int xs,int ys);
protected:
		/* Instance variables */
	GtCBList selcb;
	ulong *cmap;
	long nrcol,selnr;
	uword cols,rows;
	ubyte mode,bdrw;
	sbool sel;
};

extern GtPalette *GtMkPalette(char *n,GtManager *p,GtTag *tgs);
extern GtPalette *GtMkPalette(char *n,GtManager *p,ulong tag,...);

#endif /* INC_GTPALETTE_H */
