#include <proto.h>

#include "gtwhtman.h"
#include "gtapp.h"
#include "gterror.h"
#include "gtresname.h"
#include "gtcommon.h"

/************************************************************************\
*
* GtWhtMan class.
*
* $Ident: This file is part of the 'Gt-library' 1.0.0 $
* $Copyright: (C) 1997 by Gran Gustafsson $
*
\************************************************************************/

/************************************************************************\
*
* Check if class is (sub)class of named class.
*
\************************************************************************/
sbool GtWhtMan::IsSubClassOf(char *cn)
{
	if(strcmp(cn,"GtWhtMan")==0)
		return(TRUE);
	else
		return(GtManager::IsSubClassOf(cn));
}

/************************************************************************\
*
* Set child layout information tags.
*
\************************************************************************/
sbool GtWhtMan::SetLInfo(GtWidget *o,GtTag *tgs)
{
	GtTag *t;
	sbool res;
	GtWListWht *li;
	
	res=GtBdrMan::SetLInfo(o,tgs);
	li=(GtWListWht *)o->GetLInfo();
	while((t=GtNextTag(&tgs)))
	{
		switch(t->tag)
		{
			case GT_Weight:
				li->weight=t->d.val;
				res=TRUE;
				break;
			case GT_Place:
				li->place=t->d.val;
				if(li->place>GTP_LAST_NR)
					li->place=GTP_EXPAND;
				res=TRUE;
				break;
		}
	}
	return(res);
}

/************************************************************************\
*
* Get child layout information tags.
*
\************************************************************************/
void GtWhtMan::GetLInfo(GtWidget *o,GtTag *tgs)
{
	GtTag *t;
	GtWListWht *li;
	long *ptr;
	
	GtBdrMan::GetLInfo(o,tgs);
	li=(GtWListWht *)o->GetLInfo();
	while((t=GtNextTag(&tgs)))
	{
		if(!(ptr=(long *)t->d.ptr))
			continue;
		switch(t->tag)
		{
			case GT_Weight:
				*ptr=li->weight;
				break;
			case GT_Place:
				*ptr=li->place;
				break;
		}
	}
}

/************************************************************************\
*
* Create child layout information.
*
\************************************************************************/
GtWList *GtWhtMan::MakeWList(GtWidget *o,int sz)
{
	GtWListWht *li;

	li=(GtWListWht *)GtBdrMan::MakeWList(o,
		sz+sizeof(GtWListWht)-sizeof(GtWListBdr));
	if(!li)
		return(FALSE);
	li->weight=1;
	li->place=GTP_EXPAND;
	app->GetRes(o,GTR_WEIGHT,GTRT_WORD,&li->weight);
	app->GetRes(o,GTR_PLACE,GTRT_PLACE,&li->place);
	return((GtWList *)li);
}
